/* ===============================================
  OPEN CLOSE Menu
============================================= */

function printing_press_open_menu() {
  jQuery('button.menu-toggle').addClass('close-panal');
  setTimeout(function(){
    jQuery('nav#main-menu').show();
  }, 100);

  return false;
}

jQuery( "button.menu-toggle").on("click", printing_press_open_menu);

function printing_press_close_menu() {
  jQuery('button.close-menu').removeClass('close-panal');
  jQuery('nav#main-menu').hide();
}

jQuery( "button.close-menu").on("click", printing_press_close_menu);

function printing_press_search_show() {
	jQuery(".outer-search").addClass('show');
	jQuery(".outer-search").fadeIn();
}
jQuery( ".search-cont-button").on("click", printing_press_search_show);

function printing_press_search_hide() {
	jQuery(".outer-search").removeClass('show');
	jQuery(".outer-search").fadeOut();
}
jQuery( ".search-cont-button-close").on("click", printing_press_search_hide);

/* ===============================================
  TRAP TAB FOCUS ON MODAL MENU
============================================= */

jQuery('button.close-menu').on('keydown', function (e) {

  if (jQuery("this:focus") && !!e.shiftKey && e.keyCode === 9) {
  } else if (jQuery("this:focus") && (e.which === 9)) {
    e.preventDefault();
    jQuery(this).blur();
    jQuery('.nav-menu li a:first').focus()
  }
});

jQuery('.nav-menu li a:first').on('keydown', function (event) {
  if (jQuery("this:focus") && !!event.shiftKey && event.keyCode === 9) {
    event.preventDefault();
    jQuery(this).blur();
    jQuery('button.close-menu').focus()
  }
});

  jQuery(document).ready(function() {
    window.addEventListener('load', (event) => {
        jQuery(".loader").delay(2000).fadeOut("slow");
      });
  })

    /* ===============================================
      Scroll Top //
    ============================================= */
    
    jQuery(window).scroll(function () {
      if (jQuery(this).scrollTop() > 100) {
          jQuery('.scroll-up').fadeIn();
      } else {
          jQuery('.scroll-up').fadeOut();
      }
    });
    
    jQuery('a[href="#tobottom"]').click(function () {
      jQuery('html, body').animate({scrollTop: 0}, 'slow');
      return false;
    });
    (function( $ ) {
      $(window).scroll(function(){
          var sticky = $('.sticky-header'),
          scroll = $(window).scrollTop();
    
          if (scroll >= 100) sticky.addClass('fixed-header');
          else sticky.removeClass('fixed-header');
        });
      })( jQuery );
    (function( $ ) {
    
    $(window).scroll(function(){
        var sticky = $('.sticky-header'),
        scroll = $(window).scrollTop();
    
        if (scroll >= 100) sticky.addClass('fixed-header');
        else sticky.removeClass('fixed-header');
      });
    })( jQuery );
    
/* ===============================================
  Search pop up
============================================= */

jQuery('.search-cont-button-close').on('keydown', function (es) {
  if (jQuery("this:focus") && (es.which === 9)) {
    es.preventDefault();
    jQuery(this).blur();
    jQuery('.inner-search form input').focus();
  }
});

jQuery('.inner-search form input').on('keydown', function (eventser) {
  if (eventser.shiftKey && eventser.keyCode == 9) {
    eventser.preventDefault();
    jQuery(this).blur();
    jQuery('.search-cont-button-close').focus()
  }
});

/* ===============================================
  Custom Cursor
============================================= */

const printing_press_customCursor = {
  init: function () {
    this.printing_press_customCursor();
  },
  isVariableDefined: function (el) {
    return typeof el !== "undefined" && el !== null;
  },
  select: function (selectors) {
    return document.querySelector(selectors);
  },
  selectAll: function (selectors) {
    return document.querySelectorAll(selectors);
  },
  printing_press_customCursor: function () {
    const printing_press_cursorDot = this.select(".cursor-point");
    const printing_press_cursorOutline = this.select(".cursor-point-outline");
    if (this.isVariableDefined(printing_press_cursorDot) && this.isVariableDefined(printing_press_cursorOutline)) {
      const cursor = {
        delay: 8,
        _x: 0,
        _y: 0,
        endX: window.innerWidth / 2,
        endY: window.innerHeight / 2,
        cursorVisible: true,
        cursorEnlarged: false,
        $dot: printing_press_cursorDot,
        $outline: printing_press_cursorOutline,

        init: function () {
          this.dotSize = this.$dot.offsetWidth;
          this.outlineSize = this.$outline.offsetWidth;
          this.setupEventListeners();
          this.animateDotOutline();
        },

        updateCursor: function (e) {
          this.cursorVisible = true;
          this.toggleCursorVisibility();
          this.endX = e.clientX;
          this.endY = e.clientY;
          this.$dot.style.top = `${this.endY}px`;
          this.$dot.style.left = `${this.endX}px`;
        },

        setupEventListeners: function () {
          window.addEventListener("load", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          printing_press_customCursor.selectAll("a, button").forEach((el) => {
            el.addEventListener("mouseover", () => {
              this.cursorEnlarged = true;
              this.toggleCursorSize();
            });
            el.addEventListener("mouseout", () => {
              this.cursorEnlarged = false;
              this.toggleCursorSize();
            });
          });

          document.addEventListener("mousedown", () => {
            this.cursorEnlarged = true;
            this.toggleCursorSize();
          });
          document.addEventListener("mouseup", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          document.addEventListener("mousemove", (e) => {
            this.updateCursor(e);
          });

          document.addEventListener("mouseenter", () => {
            this.cursorVisible = true;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          });

          document.addEventListener("mouseleave", () => {
            this.cursorVisible = false;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          });
        },

        animateDotOutline: function () {
          this._x += (this.endX - this._x) / this.delay;
          this._y += (this.endY - this._y) / this.delay;
          this.$outline.style.top = `${this._y}px`;
          this.$outline.style.left = `${this._x}px`;

          requestAnimationFrame(this.animateDotOutline.bind(this));
        },

        toggleCursorSize: function () {
          if (this.cursorEnlarged) {
            this.$dot.style.transform = "translate(-50%, -50%) scale(0.75)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1.6)";
          } else {
            this.$dot.style.transform = "translate(-50%, -50%) scale(1)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1)";
          }
        },

        toggleCursorVisibility: function () {
          if (this.cursorVisible) {
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          } else {
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          }
        },
      };
      cursor.init();
    }
  },
};
printing_press_customCursor.init(); 

/* ===============================================
  Progress Bar
============================================= */
const printing_press_progressBar = {
  init: function () {
      let printing_press_progressBarDiv = document.getElementById("elemento-progress-bar");

      if (printing_press_progressBarDiv) {
          let printing_press_body = document.body;
          let printing_press_rootElement = document.documentElement;

          window.addEventListener("scroll", function (event) {
              let printing_press_winScroll = printing_press_body.scrollTop || printing_press_rootElement.scrollTop;
              let printing_press_height =
              printing_press_rootElement.scrollHeight - printing_press_rootElement.clientHeight;
              let printing_press_scrolled = (printing_press_winScroll / printing_press_height) * 100;
              printing_press_progressBarDiv.style.width = printing_press_scrolled + "%";
          });
      }
  },
};
printing_press_progressBar.init();

/* ===============================================
   sticky copyright
============================================= */

window.addEventListener('scroll', function() {
  var printing_press_footer = document.querySelector('.sticky-copyright');
  if (!printing_press_footer) return; 

  var printing_press_scrollTop = window.scrollY || document.documentElement.printing_press_scrollTop;

  if (printing_press_scrollTop >= 100) {
    printing_press_footer.classList.add('active-sticky');
  }
});

/* ===============================================
   sticky sidebar
============================================= */

window.addEventListener('scroll', function () {
  var printing_press_sidebar = document.querySelector('.sidebar-sticky');
  if (!printing_press_sidebar) return;

  var printing_press_scrollTop = window.scrollY || document.documentElement.scrollTop;
  var printing_press_windowHeight = window.innerHeight;
  var printing_press_documentHeight = document.documentElement.scrollHeight;

  var printing_press_isBottom = printing_press_scrollTop + printing_press_windowHeight >= printing_press_documentHeight - 100;

  if (printing_press_scrollTop >= 100 && !printing_press_isBottom) {
    printing_press_sidebar.classList.add('sidebar-fixed');
  } else {
    printing_press_sidebar.classList.remove('sidebar-fixed');
  }
});